package cn.com.duiba.mysql.generator.utils;

import cn.com.duiba.mysql.generator.entity.GeneratorConfig;
import cn.com.duiba.mysql.generator.exceptions.DuibaGeneratorException;
import org.apache.commons.lang.StringUtils;

import java.io.File;

public class PathUtils {
	private PathUtils() {
		//X Y
	}

	private static String getProjectHome() {
		return System.getProperty("user.dir");
	}

	/**
	 * 根据包名找到包的实际路径
	 *
	 * @param packageName 包名，例如：cn.com.duiba.shark.gitlab.dao
	 * @return 包的文件路径
	 */
	public static String getPathByPackage(String packageName, GeneratorConfig config) {
		if (StringUtils.isEmpty(packageName)) {
			throw new DuibaGeneratorException("包名不能为空");
		}
		if (StringUtils.isEmpty(config.getModuleName())) {
			return "src/main/java/" + StringUtils.replace(packageName, ".", "/");
		}
		String filePath = config.getModuleName() + File.separator + "src/main/java/" + StringUtils.replace(packageName, ".", "/");
		//以main方法执行
		if (config.isExeTest()) {
			//以测试用例的方式执行
			String modulePath = getProjectHome();
			String bathPath = modulePath.substring(0, modulePath.lastIndexOf(File.separator));
			return bathPath + File.separator + filePath;
		}

		return filePath;

	}
}
